/*************************************************  Common Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright 2014, Red Rapids, Inc.

*************************************************  Common Functions Header  **************************************************/

#ifndef _PROGRAMMER_FUNCTIONS_H_
#define _PROGRAMMER_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

typedef	struct s_FlashCode
{
	unsigned long address;
	unsigned long data;
	struct s_FlashCode *next;
} s_FlashCode;

// Prototypes for each of the common functions in alphabetic order.
unsigned long atoulint(char *HexNumber);
unsigned long BlankCheck(s_Adapter *p_HW, unsigned long StartAddress, unsigned long EndAddress);
unsigned long Erase(s_Adapter *p_HW, unsigned long StartAddress, unsigned long EndAddress);
unsigned long GetClockStatus(s_Adapter *p_HW);
s_FlashCode* MCSParser(char *MCSFileName);
unsigned long Program(s_Adapter *p_HW, s_FlashCode *p_FlashCode);
unsigned long ProgAddress(s_Adapter *p_HW, unsigned long Address);
unsigned long ProgDisable(s_Adapter *p_HW);
unsigned long ProgEnable(s_Adapter *p_HW);
unsigned long ProgInit(s_Adapter *p_HW);
unsigned long ProgRead(s_Adapter *p_HW, unsigned long *p_Value);
unsigned long ProgSegment(s_Adapter *p_HW, unsigned long Revision);
unsigned long ProgWait(s_Adapter *p_HW);
unsigned long ProgWrite(s_Adapter *p_HW, unsigned long Command);
unsigned long ReadID(s_Adapter *p_HW, unsigned long Address, unsigned long Offset, unsigned long *p_Value);
unsigned long StatusCheck(s_Adapter *p_HW, unsigned long Address, unsigned long Timer);
unsigned long StatusClear(s_Adapter *p_HW, unsigned long Address);
unsigned long StatusRead(s_Adapter *p_HW, unsigned long Address, unsigned long *p_Value);
unsigned long Unlock(s_Adapter *p_HW, unsigned long StartAddress, unsigned long EndAddress);
unsigned long Verify(s_Adapter *p_HW, s_FlashCode *p_FlashCode);

#ifdef __cplusplus
}
#endif

#endif
